package com.fp.persistence.pcustomer.company;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.GeneratedValue;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.persistence.Version;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

/**
 * Clase que implementa la entidad de Hibernate que hace referencia a la tabla
 * TCUSTCOMPANYBRANCH
 */
@Entity(name = "TcustCompanyBranch")
@Table(name = "TCUSTCOMPANYBRANCH")
public class TcustCompanyBranch extends com.fp.dto.AbstractDataTransport implements Serializable, HibernateBean, Cloneable, Log {

    /**
     * HashCode asociado con la Instancia
     */
    @Transient
    private int hashValue = 0;
    /**
     * Version de la Clase
     */
    private static final long serialVersionUID = 1L;
    /**
     * Clave primaria de la Entidad TcustCompanyBranch
     */
    @EmbeddedId
    @GenericGenerator(name = "seq_id", strategy = "com.fp.general.keygen.SubSequenceKey", parameters = {
        @Parameter(name = "sql", value = "select coalesce(max(BRANCHSEQUENCE),0)+1 from TCUSTCOMPANYBRANCH where personcode=:code"),
        @Parameter(name = "type", value = "java.lang.Integer"),
        @Parameter(name = "param", value = "code,pk.personcode"),
        @Parameter(name = "field", value = "branchsequence")})
    @GeneratedValue(generator = "seq_id")
    private TcustCompanyBranchKey pk;
    @Column(name = "DATEFROM", nullable = false)
    /**
     * Fecha desde la cual esta vigente el registro
     */
    private Timestamp datefrom;
    @Version
    @Column(name = "RECORDVERSION", nullable = true)
    /**
     * Optimistic locking del registro
     */
    private Integer recordversion;
    @Column(name = "NAME", nullable = true)
    /**
     * Nombre de la sucursal y/o oficina de representyacion
     */
    private String name;
    @Column(name = "ADDRESSNUMBER", nullable = true)
    /**
     * Numero de direccion asociada a la sucursal
     */
    private Integer addressnumber;
    @Column(name = "INGRESSUSER", nullable = true)
    /**
     * Codigo de usuario que crea el cliente
     */
    private String ingressuser;
    @Column(name = "MODIFYUSER", nullable = true)
    /**
     * Codigo de usuario que modifica datos del cliente
     */
    private String modifyuser;

    /**
     * Contructor por defecto
     */
    public TcustCompanyBranch() {
    }

    /**
     * Contructor de TcustCompanyBranch
     *
     * @param pPk Clave Primaria del entity
     * @param pDatefrom Fecha desde la cual esta vigente el registro
     */
    public TcustCompanyBranch(TcustCompanyBranchKey pPk, Timestamp pDatefrom) {
        this();
        this.pk = pPk;
        this.datefrom = pDatefrom;
    }

    /**
     * Metodo que entrega datos de la tabla dada la clave primaria.
     *
     * @param pEntityManager referencia de la session a obtener datos del bean.
     * @param pKey Caleve primaria del bean.
     * @return TcustCompanyBranch
     */
    public static TcustCompanyBranch find(EntityManager pEntityManager, TcustCompanyBranchKey pKey) throws Exception {
        TcustCompanyBranch obj = pEntityManager.find(TcustCompanyBranch.class, pKey);
        return obj;
    }

    /**
     * Entrega la Clave primaria de TcustCompanyBranch
     *
     * @return El objeto que referencia a la Clave primaria de
     * TcustCompanyBranch
     */
    public TcustCompanyBranchKey getPk() {
        return this.pk;
    }

    /**
     * Fija un nuevo valor a la Clave primaria de TcustCompanyBranch
     *
     * @param pPk El objeto que referencia a la nueva Clave primaria de
     * TcustCompanyBranch
     */
    public void setPk(TcustCompanyBranchKey pPk) {
        this.pk = pPk;
    }

    /**
     * Obtiene el valor de datefrom
     *
     * @return valor de datefrom
     */
    public Timestamp getDatefrom() {
        return this.datefrom;
    }

    /**
     * Fija el valor de datefrom
     *
     * @param pDatefrom nuevo Valor de datefrom
     */
    public void setDatefrom(Timestamp pDatefrom) {
        this.datefrom = pDatefrom;
    }

    /**
     * Obtiene el valor de recordversion
     *
     * @return valor de recordversion
     */
    public Integer getRecordversion() {
        return this.recordversion;
    }

    /**
     * Fija el valor de recordversion
     *
     * @param pRecordversion nuevo Valor de recordversion
     */
    public void setRecordversion(Integer pRecordversion) {
        this.recordversion = pRecordversion;
    }

    /**
     * Obtiene el valor de name
     *
     * @return valor de name
     */
    public String getName() {
        return this.name;
    }

    /**
     * Fija el valor de name
     *
     * @param pName nuevo Valor de name
     */
    public void setName(String pName) {
        this.name = pName;
    }

    /**
     * Obtiene el valor de addressnumber
     *
     * @return valor de addressnumber
     */
    public Integer getAddressnumber() {
        return this.addressnumber;
    }

    /**
     * Fija el valor de addressnumber
     *
     * @param pAddressnumber nuevo Valor de addressnumber
     */
    public void setAddressnumber(Integer pAddressnumber) {
        this.addressnumber = pAddressnumber;
    }

    /**
     * Obtiene el valor de ingressuser
     *
     * @return valor de ingressuser
     */
    public String getIngressuser() {
        return this.ingressuser;
    }

    /**
     * Fija el valor de ingressuser
     *
     * @param pIngressuser nuevo Valor de ingressuser
     */
    public void setIngressuser(String pIngressuser) {
        this.ingressuser = pIngressuser;
    }

    /**
     * Obtiene el valor de modifyuser
     *
     * @return valor de modifyuser
     */
    public String getModifyuser() {
        return this.modifyuser;
    }

    /**
     * Fija el valor de modifyuser
     *
     * @param pModifyuser nuevo Valor de modifyuser
     */
    public void setModifyuser(String pModifyuser) {
        this.modifyuser = pModifyuser;
    }

    @Override
    public boolean equals(Object rhs) {
        if (rhs == null) {
            return false;
        }
        if (!(rhs instanceof TcustCompanyBranch)) {
            return false;
        }
        TcustCompanyBranch that = (TcustCompanyBranch) rhs;
        if ((this.getPk() == null) || (that.getPk() == null)) {
            return false;
        }
        return (this.getPk().equals(that.getPk()));
    }

    /**
     * Implementaci�n del metodo hashCode de la la entidad TcustCompanyBranch
     *
     * @return el hashCode la instancia
     */
    @Override
    public int hashCode() {
        if (this.hashValue == 0) {
            int result = 17;
            if (this.getPk() == null) {
                result = super.hashCode();
            } else {
                result = this.getPk().hashCode();
            }
            this.hashValue = result;
        }
        return this.hashValue;
    }

    /**
     * Implementaci�n toString
     */
    @Override
    public String toString() {
        Field[] fs = this.getClass().getDeclaredFields();
        String data = "";
        for (Field f : fs) {
            try {
                String name = f.getName();
                if (f.getType().getName().compareTo("java.util.Set") == 0) {
                    continue;
                }
                if ((name.compareTo("hashValue") == 0) || (name.compareTo("serialVersionUID") == 0)) {
                    continue;
                }
                data += name + "=" + f.get(this) + ";";
            } catch (Exception e) {
                continue;
            }
        }
        if (data.compareTo("") == 0) {
            data = super.toString();
        }
        return data;
    }

    /**
     * Implementaci�n de la creaci�n de un bean en blanco TcustCompanyBranch
     */
    @Override
    public Object createInstance() {
        TcustCompanyBranch instance = new TcustCompanyBranch();
        instance.setPk(new TcustCompanyBranchKey());
        return instance;
    }

    /**
     * Clona la entidad TcustCompanyBranch
     *
     * @see com.fp.dto.hb.HibernateBean#cloneMe()
     */
    @Override
    public Object cloneMe() throws CloneNotSupportedException {
        TcustCompanyBranch p = (TcustCompanyBranch) this.clone();
        p.setPk((TcustCompanyBranchKey) this.pk.cloneMe());
        return p;
    }

    public Object getId() {
        return this.pk;
    }
}
